#include <AT91SAM7S128.h>
#include <lib_AT91SAM7S128.h>

#define LCD_PORT_A
#define LCD_RS 16
#define LCD_E 15
#define LCD_DB4	26
#define LCD_DB5	27
#define LCD_DB6	28
#define LCD_DB7	29
#include <lcd.h>

unsigned int sec,min,hor;

void tim1_isr (void) __irq
{
sec++;
if (sec==60)
{sec=0;
min++;}

if (min==60)
{min=0;
hor++;}

if (hor==24)
{
hor=0;
min=0;
sec=0;
}



AT91C_BASE_AIC->AIC_EOICR = AT91C_BASE_TC1->TC_SR;
AT91C_BASE_AIC->AIC_ICCR = (1 << AT91C_ID_TC1); /* Interrupt Ack*/
*AT91C_AIC_EOICR = 0; /* End of Interrupt*/
}

void timer_init()
{

AT91C_BASE_TC1->TC_CMR = 0x0000c004;    
AT91C_BASE_TC1->TC_RC = 180000; // period is
AT91C_BASE_TC1->TC_IER = AT91C_TC_CPCS;
/* TIM1 Interrupt: Mode and Vector with Lowest Priority and Enable */
AT91C_BASE_AIC->AIC_SMR[AT91C_ID_TC1] = AT91C_AIC_SRCTYPE_INT_POSITIVE_EDGE | 5;
AT91C_BASE_AIC->AIC_SVR[AT91C_ID_TC1] = (unsigned long) tim1_isr;
AT91C_BASE_AIC->AIC_IECR = (1 << AT91C_ID_TC1);

AT91C_BASE_TC1->TC_CCR = (AT91C_TC_CLKEN | AT91C_TC_SWTRG) ; // Enable timer
};


int main (){
  lcd_init();
  AT91F_PIO_CfgOutput(AT91C_BASE_PIOA, 0x07F80000);
  AT91C_BASE_PMC->PMC_PCER =((1 << AT91C_ID_TC1) | (0X00000004));   // Enable clock to TC0
  *AT91C_PIOA_PER |=0xfffffffe;//((1<<8)|(1<<7)|(1<<23)|(1<<10));
  *AT91C_PIOA_IFDR|=0x0ffff000;
  *AT91C_PIOA_OER|=((1<<8)|(1<<7)|(1<<10));
 
  timer_init();
lcd_clear();
lcd_gotoxy(1,5);
lcd_putsf("WATCH");
hor=8;
min=36;
sec=0;
while (1)
{
lcd_gotoxy(2,4);
lcd_puts(hor);
lcd_putsf(":");
lcd_puts(min);
lcd_putsf(":");
lcd_puts(sec);
lcd_putsf(" ");
;
};
}